struct VarAssimVectorField
    vf :: Function 

    D :: Int 
    OC :: Int 
    P :: Int 
    SC :: Int
end

struct VarAssimTimestepResidualCost
    timestep_residual :: Function 
    timestep_cost :: Function 

    R :: Int 
    NC :: Int
end

struct VarAssimBounds
    #for each variable, the tuple has order (lowerbound, upperbound, initvalue)
    u_bds :: Vector{Tuple}
    oc_bds :: Vector{Tuple}
    p_bds :: Vector{Tuple}
end

struct VarAssimObservations
    knot_times :: Vector #timepoints of knots -- has length N+1
    SC_rec :: Vector #vector of length SC*(N*(R+1)+1)
    N :: Int #number of timesteps == length(knot_times)-1

    VarAssimObservations(knot_times,SC_rec) = new(knot_times, SC_rec, length(knot_times)-1)
end